'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 1 June 2000 at 4:21:41 pm'!
"Change Set:		110PackBrOptBnt-rh
Date:			28 May 2000
Author:			Robert Hirschfeld

Fixes PackageBrowser>>openAsMorphEditing: to be sensitive to
Preferences for #annotationPanes and #optionalButtons."!


!PackageBrowser methodsFor: 'initialize-release' stamp: 'rhi 5/28/2000 11:29'!
openAsMorphEditing: editString
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	"PackageBrowser openBrowser"


	| listHeight buttonHeight window switches codePane aListMorph baseline aTextMorph |
	listHeight := 0.4.
	buttonHeight := 0.09.
	window _ (SystemWindow labelled: 'later') model: self.


	window addMorph: (PluggableListMorph on: self list: #packageList
			selected: #packageListIndex changeSelected: #packageListIndex:
			menu: #packageMenu: keystroke: #packageListKey:from:)
		frame: (0@0 extent: 0.15@listHeight).


	window addMorph: (PluggableListMorph on: self list: #systemCategoryList
			selected: #systemCategoryListIndex changeSelected: #systemCategoryListIndex:
			menu: #systemCategoryMenu: keystroke: #systemCatListKey:from:)
		frame: (0.15@0 extent: 0.2@listHeight).


	window addMorph: (PluggableListMorph on: self list: #classList
			selected: #classListIndex changeSelected: #classListIndex:
			menu: #classListMenu: keystroke: #classListKey:from:)
		frame: (0.35@0 extent: 0.25@(listHeight - buttonHeight)).


	switches _ self buildMorphicSwitches.
	window addMorph: switches frame: (0.35@(listHeight - buttonHeight) 
				extent: 0.25@buttonHeight).
	switches borderWidth: 0.


	window addMorph: (PluggableListMorph on: self list: #messageCategoryList
			selected: #messageCategoryListIndex changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu:)
		frame: (0.6@0 extent: 0.15@listHeight).
	aListMorph _ PluggableListMorph on: self list: #messageList
			selected: #messageListIndex changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	window addMorph: aListMorph
		frame: (0.75@0 extent: 0.25@listHeight).


	Preferences useAnnotationPanes
		ifFalse:
			[baseline _ listHeight]
		ifTrue:
			[baseline _ listHeight + 0.05.
			aTextMorph _ PluggableTextMorph on: self
					text: #annotation accept: nil
					readSelection: nil menu: nil.
			aTextMorph askBeforeDiscardingEdits: false.
			window addMorph: aTextMorph
				frame: (0@listHeight corner: 1@baseline)].


	Preferences optionalButtons
		ifTrue:
			[window addMorph: self optionalButtonRow
				frame: (0@baseline corner: 1@(baseline + 0.08)).
			baseline _ baseline + 0.08].


	codePane _ PluggableTextMorph on: self text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	editString ifNotNil: [codePane editString: editString.
					codePane hasUnacceptedEdits: true].
	window addMorph: codePane
		frame: (0 @ baseline corner: 1 @ 1).


	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	^ window! !

